﻿#region Namespace
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading;
using System.Media;
using System.Windows.Forms;
using System.Windows.Media;

using System.ComponentModel;
using System.Drawing.Design;
using System.Globalization;
using System.Reflection;

using MColors = System.Drawing.Brushes;
using System.Runtime.InteropServices;
using System.Xml;
using System.Xml.Linq;
using System.Net;
using Encoding = System.Text.Encoding;
using UTF8Encoding = System.Text.UTF8Encoding;

using CommonBehaviors;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Plugins;
//using Styx.MemoryManagement;
using DefaultValue = Styx.Helpers.DefaultValueAttribute;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWCache;
using Styx.WoWInternals.WoWObjects;


#endregion Namespace

namespace AlishaInvite
{

    public class AlishaInvite : HBPlugin
    {
        private static string PName = "AlishaInvite";
        public override string Name { get { return PName; } }
        public override string Author { get { return "Alisha"; } }
        public override Version Version { get { return new Version(1, 2); } }
        public override bool WantButton { get { return false; } }
        private string SoundFileInvite { get { return Path.Combine(FolderPath + "\\Sounds", "invite.wav"); }}
        private string SoundFileResurect{ get { return Path.Combine(FolderPath + "\\Sounds", "resurect.wav"); } }
        private string SoundFileReadyCheck { get { return Path.Combine(FolderPath + "\\Sounds", "ready_check.wav"); } }
        static public string FolderPath
        {
            get
            {
                string sPath = Process.GetCurrentProcess().MainModule.FileName;
                sPath = Path.GetDirectoryName(sPath);
                sPath = Path.Combine(sPath, "Plugins\\" + PName + "\\");
                return sPath;
            }
        }


        public override void Initialize()
        {
            Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", LFGInvite);
            Lua.Events.AttachEvent("READY_CHECK", ReadyCheck);
            Lua.Events.AttachEvent("QUEST_ACCEPT_CONFIRM", QuestAccept);
            Lua.Events.AttachEvent("RESURRECT_REQUEST", ResurrectAccept);
            Log("Loaded Version " + Version);
        }
        public override void Pulse() { }
        #region Lua Events Functions
        public void LFGInvite(object sender, LuaEventArgs args)
        {
            new SoundPlayer(SoundFileInvite).Play();
            Random r = new Random();
            Log("Got Dungeon invite, Entering in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("RunMacroText(\"/click LFGDungeonReadyDialogEnterDungeonButton\");");
            Lua.DoString("/script AcceptProposal();");
        }
        public void ReadyCheck(object sender, LuaEventArgs args)
        {
            new SoundPlayer(SoundFileReadyCheck).Play();
            Random r = new Random();
            Log("Got Ready Check, clicking Ready Button in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\");");
        }
        public void QuestAccept(object sender, LuaEventArgs args)
        {
            new SoundPlayer(SoundFileInvite).Play();
            Random r = new Random();
            Log("Got Quest Dialog, clicking Accept Button in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("/script AcceptQuest();");
        }
        public void ResurrectAccept(object sender, LuaEventArgs args)
        {
            new SoundPlayer(SoundFileResurect).Play();
            Random r = new Random();
            Log("Got Resurect Request, clicking Accept Button in 1.5 - 3.5 seconds");
            Thread.Sleep(r.Next(1500, 3500));
            Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
        }
        #endregion
        public override void Dispose()
        {
            Lua.Events.DetachEvent("LFG_PROPOSAL_SHOW", LFGInvite);
            Lua.Events.DetachEvent("READY_CHECK", ReadyCheck);
            Lua.Events.DetachEvent("QUEST_ACCEPT_CONFIRM", QuestAccept);
            Lua.Events.DetachEvent("RESURRECT_REQUEST", ResurrectAccept);
            Log("Finished");
        }
        public static void Log(string msg)
        {
            Logging.Write(Colors.Aqua, "[AlishaInvite]: " + msg);
        }
        public static void Log(string msg, params object[] args)
        {
            Logging.Write(Colors.Aqua, "[AlishaInvite]: " + msg, args);
        }
    }
}